#ifndef _DECL_parallelJacobi_H_
#define _DECL_parallelJacobi_H_
#include "charm++.h"
#ifdef CMK_CHECK_CRC
extern "C" void checkAllCRC(int);
#endif
/* DECLS: message Msg{
double strip[];
}
;
 */
class Msg;
class CMessage_Msg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p, int*, const int){CkFreeMsg(p);}
    void operator delete(void*p, int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p, size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t, int*, int);
    CMessage_Msg() {};
    static void *pack(Msg *p);
    static Msg* unpack(void* p);
    void *operator new(size_t, int);
    void *operator new(size_t, int, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, int){CkFreeMsg(p);}
    void operator delete(void *p, int, const int){CkFreeMsg(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: message MaxMsg;
 */
class MaxMsg;
class CMessage_MaxMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p, int*, const int){CkFreeMsg(p);}
    void operator delete(void*p, int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p, size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t, int*, int);
    CMessage_MaxMsg() {};
    static void *pack(MaxMsg *p);
    static MaxMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){CkFreeMsg(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: message VoidMsg;
 */
class VoidMsg;
class CMessage_VoidMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){CkFreeMsg(p);}
    void operator delete(void*p){ CkFreeMsg(p);}
    void operator delete(void*p, int*, const int){CkFreeMsg(p);}
    void operator delete(void*p, int*){CkFreeMsg(p);}
#endif
    void operator delete(void*p, size_t){CkFreeMsg(p);}
    static void* alloc(int,size_t, int*, int);
    CMessage_VoidMsg() {};
    static void *pack(VoidMsg *p);
    static VoidMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){CkFreeMsg(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: mainchare Main: Chare{
Main(CkArgMsg* impl_msg);
};
 */
 class Main;
 class CkIndex_Main;
 class CProxy_Main;
/* --------------- index object ------------------ */
class CkIndex_Main:public CProxy_Chare{
  public:
    typedef Main local_t;
    typedef CkIndex_Main index_t;
    typedef CProxy_Main proxy_t;
    typedef CProxy_Main element_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: Main(CkArgMsg* impl_msg);
 */
    static int __idx_Main_CkArgMsg;
    static int ckNew(CkArgMsg* impl_msg) { return __idx_Main_CkArgMsg; }
    static void _call_Main_CkArgMsg(void* impl_msg,Main* impl_obj);
};
/* --------------- element proxy ------------------ */
class CProxy_Main:public CProxy_Chare{
  public:
    typedef Main local_t;
    typedef CkIndex_Main index_t;
    typedef CProxy_Main proxy_t;
    typedef CProxy_Main element_t;

    CProxy_Main(void) {};
    CProxy_Main(CkChareID __cid) : CProxy_Chare(__cid){  }
    CProxy_Main(const Chare *c) : CProxy_Chare(c){  }
    CK_DISAMBIG_CHARE(CProxy_Chare)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_Chare::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_Chare::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_Chare::pup(p);
    }
    void ckSetChareID(const CkChareID &c) {
      CProxy_Chare::ckSetChareID(c);
    }
    Main *ckLocal(void) const
     { return (Main *)CkLocalChare(&ckGetChareID()); }
/* DECLS: Main(CkArgMsg* impl_msg);
 */
    static CkChareID ckNew(CkArgMsg* impl_msg, int onPE=CK_PE_ANY);
    static void ckNew(CkArgMsg* impl_msg, CkChareID* pcid, int onPE=CK_PE_ANY);
    CProxy_Main(CkArgMsg* impl_msg, int onPE=CK_PE_ANY);
};
PUPmarshall(CProxy_Main);
typedef CBaseT<Chare,CProxy_Main>  CBase_Main;

/* DECLS: readonly CProxy_Main globalMainProxy;
 */

/* DECLS: readonly CProxy_Chunk chunk_arr;
 */

/* DECLS: readonly int numFinished;
 */

/* DECLS: array Chunk: ArrayElement{
Chunk(CkMigrateMessage* impl_msg);
Chunk(int impl_noname_0, int impl_noname_1, int impl_noname_2);
void getStripfromleft(Msg* impl_msg);
void getStripfromright(Msg* impl_msg);
void processStripfromleft(Msg* impl_msg);
void processStripfromright(Msg* impl_msg);
void startWork(void);
void singleStep(VoidMsg* impl_msg);
};
 */
 class Chunk;
 class CkIndex_Chunk;
 class CProxy_Chunk;
 class CProxyElement_Chunk;
 class CProxySection_Chunk;
/* --------------- index object ------------------ */
class CkIndex_Chunk:public CProxyElement_ArrayElement{
  public:
    typedef Chunk local_t;
    typedef CkIndex_Chunk index_t;
    typedef CProxy_Chunk proxy_t;
    typedef CProxyElement_Chunk element_t;
    typedef CProxySection_Chunk section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: Chunk(CkMigrateMessage* impl_msg);
 */
    static int __idx_Chunk_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_Chunk_CkMigrateMessage; }
    static void _call_Chunk_CkMigrateMessage(void* impl_msg,Chunk* impl_obj);

/* DECLS: Chunk(int impl_noname_0, int impl_noname_1, int impl_noname_2);
 */
    static int __idx_Chunk_marshall1;
    static int ckNew(int impl_noname_0, int impl_noname_1, int impl_noname_2) { return __idx_Chunk_marshall1; }
    static void _call_Chunk_marshall1(void* impl_msg,Chunk* impl_obj);
    static int _callmarshall_Chunk_marshall1(char* impl_buf,Chunk* impl_obj);
    static void _marshallmessagepup_Chunk_marshall1(PUP::er &p,void *msg);

/* DECLS: void getStripfromleft(Msg* impl_msg);
 */
    static int __idx_getStripfromleft_Msg;
    static int getStripfromleft(Msg* impl_msg) { return __idx_getStripfromleft_Msg; }
    static void _call_getStripfromleft_Msg(void* impl_msg,Chunk* impl_obj);

/* DECLS: void getStripfromright(Msg* impl_msg);
 */
    static int __idx_getStripfromright_Msg;
    static int getStripfromright(Msg* impl_msg) { return __idx_getStripfromright_Msg; }
    static void _call_getStripfromright_Msg(void* impl_msg,Chunk* impl_obj);

/* DECLS: void processStripfromleft(Msg* impl_msg);
 */
    static int __idx_processStripfromleft_Msg;
    static int processStripfromleft(Msg* impl_msg) { return __idx_processStripfromleft_Msg; }
    static void _call_processStripfromleft_Msg(void* impl_msg,Chunk* impl_obj);

/* DECLS: void processStripfromright(Msg* impl_msg);
 */
    static int __idx_processStripfromright_Msg;
    static int processStripfromright(Msg* impl_msg) { return __idx_processStripfromright_Msg; }
    static void _call_processStripfromright_Msg(void* impl_msg,Chunk* impl_obj);

/* DECLS: void startWork(void);
 */
    static int __idx_startWork_void;
    static int startWork(void) { return __idx_startWork_void; }
    static void _call_startWork_void(void* impl_msg,Chunk* impl_obj);

/* DECLS: void singleStep(VoidMsg* impl_msg);
 */
    static int __idx_singleStep_VoidMsg;
    static int singleStep(VoidMsg* impl_msg) { return __idx_singleStep_VoidMsg; }
    static void _call_singleStep_VoidMsg(void* impl_msg,Chunk* impl_obj);
};
/* --------------- element proxy ------------------ */
 class CProxyElement_Chunk : public CProxyElement_ArrayElement{
  public:
    typedef Chunk local_t;
    typedef CkIndex_Chunk index_t;
    typedef CProxy_Chunk proxy_t;
    typedef CProxyElement_Chunk element_t;
    typedef CProxySection_Chunk section_t;

    CProxyElement_Chunk(void) {}
    CProxyElement_Chunk(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_ELEMENT(CProxyElement_ArrayElement)
    Chunk *ckLocal(void) const
      { return (Chunk *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_Chunk(const CkArrayID &aid,const CkArrayIndex1D &idx,CK_DELCTOR_PARAM)
        :CProxyElement_ArrayElement(aid,idx,CK_DELCTOR_ARGS) {}
    CProxyElement_Chunk(const CkArrayID &aid,const CkArrayIndex1D &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: Chunk(CkMigrateMessage* impl_msg);
 */

/* DECLS: Chunk(int impl_noname_0, int impl_noname_1, int impl_noname_2);
 */
    void insert(int impl_noname_0, int impl_noname_1, int impl_noname_2, int onPE=-1, const CkEntryOptions *impl_e_opts=NULL);
/* DECLS: void getStripfromleft(Msg* impl_msg);
 */
    void getStripfromleft(Msg* impl_msg) ;

/* DECLS: void getStripfromright(Msg* impl_msg);
 */
    void getStripfromright(Msg* impl_msg) ;

/* DECLS: void processStripfromleft(Msg* impl_msg);
 */
    void processStripfromleft(Msg* impl_msg) ;

/* DECLS: void processStripfromright(Msg* impl_msg);
 */
    void processStripfromright(Msg* impl_msg) ;

/* DECLS: void startWork(void);
 */
    void startWork(void) ;

/* DECLS: void singleStep(VoidMsg* impl_msg);
 */
    void singleStep(VoidMsg* impl_msg) ;
};
PUPmarshall(CProxyElement_Chunk);
/* ---------------- collective proxy -------------- */
 class CProxy_Chunk : public CProxy_ArrayElement{
  public:
    typedef Chunk local_t;
    typedef CkIndex_Chunk index_t;
    typedef CProxy_Chunk proxy_t;
    typedef CProxyElement_Chunk element_t;
    typedef CProxySection_Chunk section_t;

    CProxy_Chunk(void) {}
    CProxy_Chunk(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY(CProxy_ArrayElement)
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_Chunk operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_Chunk(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_Chunk operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_Chunk(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_Chunk operator [] (int idx) const 
        {return CProxyElement_Chunk(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxyElement_Chunk operator () (int idx) const 
        {return CProxyElement_Chunk(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxy_Chunk(const CkArrayID &aid,CK_DELCTOR_PARAM) 
        :CProxy_ArrayElement(aid,CK_DELCTOR_ARGS) {}
    CProxy_Chunk(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: Chunk(CkMigrateMessage* impl_msg);
 */

/* DECLS: Chunk(int impl_noname_0, int impl_noname_1, int impl_noname_2);
 */
    static CkArrayID ckNew(int impl_noname_0, int impl_noname_1, int impl_noname_2, const CkArrayOptions &opts, const CkEntryOptions *impl_e_opts=NULL);
    static CkArrayID ckNew(int impl_noname_0, int impl_noname_1, int impl_noname_2, const int s1, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void getStripfromleft(Msg* impl_msg);
 */
    void getStripfromleft(Msg* impl_msg) ;

/* DECLS: void getStripfromright(Msg* impl_msg);
 */
    void getStripfromright(Msg* impl_msg) ;

/* DECLS: void processStripfromleft(Msg* impl_msg);
 */
    void processStripfromleft(Msg* impl_msg) ;

/* DECLS: void processStripfromright(Msg* impl_msg);
 */
    void processStripfromright(Msg* impl_msg) ;

/* DECLS: void startWork(void);
 */
    void startWork(void) ;

/* DECLS: void singleStep(VoidMsg* impl_msg);
 */
    void singleStep(VoidMsg* impl_msg) ;
};
PUPmarshall(CProxy_Chunk);
/* ---------------- section proxy -------------- */
 class CProxySection_Chunk : public CProxySection_ArrayElement{
  public:
    typedef Chunk local_t;
    typedef CkIndex_Chunk index_t;
    typedef CProxy_Chunk proxy_t;
    typedef CProxyElement_Chunk element_t;
    typedef CProxySection_Chunk section_t;

    CProxySection_Chunk(void) {}
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_SECTION(CProxySection_ArrayElement)
//Generalized array indexing:
    CProxyElement_Chunk operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_Chunk(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_Chunk operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_Chunk(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_Chunk operator [] (int idx) const 
        {return CProxyElement_Chunk(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    CProxyElement_Chunk operator () (int idx) const 
        {return CProxyElement_Chunk(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndex1D *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
    static CkSectionID ckNew(const CkArrayID &aid, int l, int u, int s) {
      CkVec<CkArrayIndex1D> al;
      for (int i=l; i<=u; i+=s) al.push_back(CkArrayIndex1D(i));
      return CkSectionID(aid, al.getVec(), al.size());
    } 
    CProxySection_Chunk(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_Chunk(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_Chunk(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: Chunk(CkMigrateMessage* impl_msg);
 */

/* DECLS: Chunk(int impl_noname_0, int impl_noname_1, int impl_noname_2);
 */

/* DECLS: void getStripfromleft(Msg* impl_msg);
 */
    void getStripfromleft(Msg* impl_msg) ;

/* DECLS: void getStripfromright(Msg* impl_msg);
 */
    void getStripfromright(Msg* impl_msg) ;

/* DECLS: void processStripfromleft(Msg* impl_msg);
 */
    void processStripfromleft(Msg* impl_msg) ;

/* DECLS: void processStripfromright(Msg* impl_msg);
 */
    void processStripfromright(Msg* impl_msg) ;

/* DECLS: void startWork(void);
 */
    void startWork(void) ;

/* DECLS: void singleStep(VoidMsg* impl_msg);
 */
    void singleStep(VoidMsg* impl_msg) ;
};
PUPmarshall(CProxySection_Chunk);
#define Chunk_SDAG_CODE \
public:\
  void singleStep(VoidMsg * msg) {\
    _slist_0(msg);\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, _dummyEP, CkMyPe(), 0, NULL); \
  }\
\
private:\
  void singleStep_end(VoidMsg * msg) {\
  }\
\
  void _slist_0(VoidMsg * msg) {\
    _atomic_0(msg);\
  }\
  void _slist_0_end(VoidMsg * msg) {\
    singleStep_end(msg);\
  }\
  void _atomic_0(VoidMsg * msg) {\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, __idx_Chunk_startwork, CkMyPe(), 0, NULL); \
    	 		\
			/*delete msg;*/ \
			startWork();\
		\
    _TRACE_END_EXECUTE(); \
    _overlap_0(msg);\
  }\
\
  void _overlap_0(VoidMsg * msg) {\
    _olist_0(msg);\
  }\
  void _overlap_0_end(VoidMsg * msg) {\
    _atomic_3(msg);\
  }\
  void _olist_0(VoidMsg * msg) {\
    CCounter *_co0= new CCounter(2);\
    _when_0(msg, _co0);\
    _when_1(msg, _co0);\
  }\
  void _olist_0_end(VoidMsg * msg, CCounter * _co0) {\
    _co0->decrement();\
    if (_co0->isDone()) {\
      delete _co0;\
      _overlap_0_end(msg);\
    }\
  }\
  int _when_0(VoidMsg * msg, CCounter * _co0) {\
    CMsgBuffer *aMessage_buf;\
    Msg *aMessage;\
\
    aMessage_buf = __cDep->getMessage(0);\
\
    if ((aMessage_buf != 0)) {\
       aMessage = (Msg *) aMessage_buf->msg;\
       __cDep->removeMessage(aMessage_buf);\
       delete aMessage_buf;\
       _slist_1(msg, _co0, aMessage);\
       return 1;\
    } else {\
       CWhenTrigger *tr;\
       tr = new CWhenTrigger(0, 2, 0, 1);\
       tr->args[0] = (size_t) msg;\
       tr->args[1] = (size_t) _co0;\
       tr->anyEntries[0] = 0;\
       __cDep->Register(tr);\
       return 0;\
    }\
  }\
\
  void _when_0_end(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _olist_0_end(msg, _co0);\
  }\
\
  void _slist_1(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _atomic_1(msg, _co0, aMessage);\
  }\
  void _slist_1_end(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _when_0_end(msg, _co0, aMessage);\
  }\
  void _atomic_1(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, __idx_Chunk_fromLeft, CkMyPe(), 0, NULL); \
    processStripfromleft(aMessage);\
    _TRACE_END_EXECUTE(); \
    _slist_1_end(msg, _co0, aMessage);\
  }\
\
  int _when_1(VoidMsg * msg, CCounter * _co0) {\
    CMsgBuffer *aMessage_buf;\
    Msg *aMessage;\
\
    aMessage_buf = __cDep->getMessage(1);\
\
    if ((aMessage_buf != 0)) {\
       aMessage = (Msg *) aMessage_buf->msg;\
       __cDep->removeMessage(aMessage_buf);\
       delete aMessage_buf;\
       _slist_2(msg, _co0, aMessage);\
       return 1;\
    } else {\
       CWhenTrigger *tr;\
       tr = new CWhenTrigger(1, 2, 0, 1);\
       tr->args[0] = (size_t) msg;\
       tr->args[1] = (size_t) _co0;\
       tr->anyEntries[0] = 1;\
       __cDep->Register(tr);\
       return 0;\
    }\
  }\
\
  void _when_1_end(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _olist_0_end(msg, _co0);\
  }\
\
  void _slist_2(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _atomic_2(msg, _co0, aMessage);\
  }\
  void _slist_2_end(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _when_1_end(msg, _co0, aMessage);\
  }\
  void _atomic_2(VoidMsg * msg, CCounter * _co0, Msg * aMessage) {\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, __idx_Chunk_fromRight, CkMyPe(), 0, NULL); \
    processStripfromright(aMessage);\
    _TRACE_END_EXECUTE(); \
    _slist_2_end(msg, _co0, aMessage);\
  }\
\
  void _atomic_3(VoidMsg * msg) {\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, __idx_Chunk_doWork, CkMyPe(), 0, NULL); \
    \
			doWork();\
			if(iterations == 3)\
				{ /*BgPrint0("Real Iter: %e\n"); */}\
			else\
				thisProxy[thisIndex].singleStep(new VoidMsg);\
			testEnd();\
\
		\
    _TRACE_END_EXECUTE(); \
    _slist_0_end(msg);\
  }\
\
public:\
  void getStripfromleft(Msg *aMessage_msg) {\
    CWhenTrigger *tr;\
    void* _bgParentLog = NULL;\
    CMsgBuffer* cmsgbuf;\
    cmsgbuf = __cDep->bufferMessage(0, (void *) aMessage_msg,  (void *) _bgParentLog, 0);\
    tr = __cDep->getTrigger(0, 0);\
    if (tr == 0)\
      return;\
    _TRACE_END_EXECUTE(); \
    _when_0((VoidMsg *) tr->args[0], (CCounter *) tr->args[1]);\
    delete tr;\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, _dummyEP, CkMyPe(), 0, NULL); \
    return;\
  }\
\
  void getStripfromright(Msg *aMessage_msg) {\
    CWhenTrigger *tr;\
    void* _bgParentLog = NULL;\
    CMsgBuffer* cmsgbuf;\
    cmsgbuf = __cDep->bufferMessage(1, (void *) aMessage_msg,  (void *) _bgParentLog, 0);\
    tr = __cDep->getTrigger(1, 0);\
    if (tr == 0)\
      return;\
    _TRACE_END_EXECUTE(); \
    _when_1((VoidMsg *) tr->args[0], (CCounter *) tr->args[1]);\
    delete tr;\
    _TRACE_BEGIN_EXECUTE_DETAILED(-1, -1, _dummyEP, CkMyPe(), 0, NULL); \
    return;\
  }\
\
private:\
  CDep *__cDep;\
  void __sdag_init(void) {\
    __cDep = new CDep(2,2);\
    __cDep->addDepends(0,0);\
    __cDep->addDepends(1,1);\
  }\
public:\
  void __sdag_pup(PUP::er& p) {\
    if (__cDep) { __cDep->pup(p); }\
  }\
  static void __sdag_register() {\
\
    __idx_Chunk_startwork = CkRegisterEp("Chunk_startwork(void)", NULL, 0, CkIndex_Chunk::__idx, 0);\
    __idx_Chunk_fromLeft = CkRegisterEp("Chunk_fromLeft(void)", NULL, 0, CkIndex_Chunk::__idx, 0);\
    __idx_Chunk_fromRight = CkRegisterEp("Chunk_fromRight(void)", NULL, 0, CkIndex_Chunk::__idx, 0);\
    __idx_Chunk_doWork = CkRegisterEp("Chunk_doWork(void)", NULL, 0, CkIndex_Chunk::__idx, 0);\
  }\
  static int __idx_Chunk_startwork;\
  static int __idx_Chunk_fromLeft;\
  static int __idx_Chunk_fromRight;\
  static int __idx_Chunk_doWork;\

#define Chunk_SDAG_CODE_DEF \
  int Chunk::__idx_Chunk_startwork=0;\
  int Chunk::__idx_Chunk_fromLeft=0;\
  int Chunk::__idx_Chunk_fromRight=0;\
  int Chunk::__idx_Chunk_doWork=0;\

typedef CBaseT<ArrayElementT<CkIndex1D>,CProxy_Chunk>  CBase_Chunk;

extern void _registerparallelJacobi(void);
extern "C" void CkRegisterMainModule(void);
#endif
